(map load (list "cavelibs.arc"
		"os.arc"))

(def handle-socket (s threadlife threadname fnhandle)
  (let (i o ip) (socket-accept s)
       (withs (th1 nil th2 nil)
	      (= th1 (thread
		      (after (fnhandle i o ip)
			     (close i o)
			     (kill-thread th2))))
	      (= th2 (thread
		      (sleep threadlife)
		      (unless (dead th1)
			      (prn (str threadname " thread took too long for " ip))
			      (break-thread th1)
			      (force-close i o)))))))

(def start-socket (port threadlife srvname fnhandle)
  (thread
   (w/socket s port
	     (prn "ready to serve port " port  " for " srvname)
	     (flushout)
	     (while t
		    (errsafe
		     (handle-socket s threadlife srvname
				    (fn (i o ip)
					(fnhandle i o ip))))))))

(= server-port* 1415)
(= server-timeout* 10)
(= server-master* "104.236.73.78")
(= server-master* "127.0.0.1")
(def server-get ()
  (tostring (system (str "echo '(main)' | netcat -w " server-timeout* " " server-master* " " server-port*))))

(def client-load ()
  (map load (list "cavelamp_client.arc"
		  "ui.arc")))

(def server-load ()
  (map load (list "cavelamp_server.arc")))

(def main (kind)
  (os-ensure)
  (if (is kind "client")
      (do (client-load)
	  (client-main))
      (is kind "server")
      (do (server-load)
	  (server-main))))
