; Assume the "operating system" offers this functionality

(def os-name () (tostring (system "uname | xargs echo -n")))

(def os-tool (name) (isnt (tostring (system (str "which " name))) ""))

(def os-tool-version-ok (cmd out)
  (withs (ret (tostring (system cmd)))
	 (if (no (is (str out "
") ret))
	     (do (prn (str "Invalid version '" ret "'"))
		 (quit)))))

(def os-tool-runs (cmd)
  (withs (ret (tostring (system (str cmd " > /dev/null 2>&1; echo $?"))))
	 (if (is ret "0
")
	     t (do (prn (str "The tool '" cmd "' does not run"))
		   nil))))

(def os-ensure ()
  (each cmd (list "which" "ls" "cat" "wc" "awk" "xargs" "echo" "nc")
	(if (no (os-tool cmd))
	    (do (prn "Missing command " cmd ".")
		(quit)))))
