#!/bin/bash

TAG_PREFIX=CAVELAMP_RELEASE_
REP=svn+ssh://mkgnu@mkgnu.net/projects/cavelamp/
VERSION_LAST=`svn ls $REP/tags | grep -i $TAG_PREFIX | sort -n | tail -1 | sed -e 's/.*_//' | sed -e 's:/::g'`
echo " ----> Last version: " $VERSION_LAST


if [ $# != 1 ]; then
    echo "Usage: $0 <new_version>"
    exit
else
    VERSION_NEW=$1
fi


echo " ----> New  version: " $VERSION_NEW
SERVER_DIR=/var/www-virtual/mkgnu.net/files/files/cavelamp
LOCAL_DIR=$TAG_PREFIX$VERSION_NEW

./clean.sh

cd ..
rm -rf $LOCAL_DIR > /dev/null
mkdir $LOCAL_DIR
cp -Rp arc3.1 $LOCAL_DIR/.
tar -czvf $LOCAL_DIR.tar.gz $LOCAL_DIR

echo -n " ----> Tag description (leave blank to NOT tag): "
read tag
if [ "$tag" != "" ]; then
    echo -n " ----> Tagging trunk as: tags/$TAG_PREFIX$VERSION_NEW"
    svn cp -m "$tag" $REP/trunk $REP/tags/$TAG_PREFIX$VERSION_NEW
fi
echo -n " ----> Push $VERSION_NEW to the server [y/N]: "
read response

if [ "$response" = "y" ]; then
    ssh root@mkgnu.net "mkdir -p $SERVER_DIR/$LOCAL_DIR;"
    scp $LOCAL_DIR.tar.gz root@mkgnu.net:$SERVER_DIR/$LOCAL_DIR/.
    ssh root@mkgnu.net "chown -R www-data.www-data " $SERVER_DIR
fi
rm -rf $LOCAL_DIR
